import java.util.Vector;
import jess.*;

public class ExpertBuy {
	public Supplier winner;
	private Vector<Supplier> suppliers = new Vector<Supplier>();
	private int quantity;
	
	public ExpertBuy (Vector<Supplier> sup, int qtd) {
		winner = null;
		suppliers = sup;
		quantity = qtd;
		run();
	}
	
	public void run() {
		try {
			Rete r = new Rete();
			r.clear();
			r.batch("se.clp");
			r.assertString("(quantidade_necessaria " + quantity + ")");
			for (int i = 0; i < suppliers.size(); i++) {
				Supplier s = suppliers.get(i);
				String str =
					"(fornecedor " +
					"(codigo \"" + s.name + "\") " +
					"(preco " + s.value + ") " +
					"(confianca " + s.trust + ") " +
					"(quantidade " + s.quantity + ") )";
				r.assertString(str);
			}
			r.run();
			Value v = r.getGlobalContext().getVariable("*vencedor*");
			String winnerName = v.toString();
			for (int i = 0; i < suppliers.size(); i++) {
				Supplier s = suppliers.get(i);
				if (winnerName.contains(s.name)) {
					winner = s;
				}
			}
		} catch (JessException ex) {
			System.err.println(ex);
		}	
	}
}
