;; Desenvolvido por Saulo Popov Zambiasi
;; UFSC - CTC - DAS - GSIGMA 

;; Usado apenas para testes
;;(clear)

;; Pesquisa em largura

(set-strategy breadth)
;(set-strategy deep)

;; Assertar um fato na forma (quantidade_necessaria ?size)

(defglobal ?*vencedor* = -1)

(deftemplate fornecedor
	(slot codigo)		;
	(slot preco)		;
	(slot confianca)	;
	(slot quantidade)	; 
)

;; Usado apenas para testes
;(deffacts instancias-iniciais
;	(quantidade_necessaria 50)
;
;	(fornecedor
;		(codigo "001")
;		(preco 10)
;		(confianca 3)
;		(quantidade 40)
;	)
;
;	(fornecedor
;		(codigo "002")
;		(preco 13)
;		(confianca 5)
;		(quantidade 40)
;	)
;
;	(fornecedor
;		(codigo "003")
;		(preco 15)
;		(confianca 1)
;		(quantidade 40)
;	)
;)

;; Encontra o fornecedor que tem a maior confianca

(defrule escolhe-maior-confianca-inicio
	(fornecedor
		(codigo ?codigo)
		(confianca ?confianca)
	)
	(not (maior-confianca ? ?))
=>
	(assert (maior-confianca ?codigo ?confianca))
	(printout t "regra > escolhe-maior-confianca-inicio - maior-confianca = " ?codigo crlf)
)

(defrule escolhe-maior-confianca
	(fornecedor
		(codigo ?codigo)
		(confianca ?confianca)
	)
	?f <- (maior-confianca ?maior-codigo ?maior-confianca&:(> ?confianca ?maior-confianca))
=>
	(retract ?f)
	(assert (maior-confianca ?codigo ?confianca))
	(printout t "regra > escolhe-maior-confianca - maior-confianca = " ?codigo crlf)
)

;; Encontra o fornecedor que tem o menor preco

(defrule escolhe-menor-preco-inicio
	(fornecedor
		(codigo ?codigo)
		(preco ?preco)
	)
	(not (menor-preco ? ?))
=>
	(assert (menor-preco ?codigo ?preco))
	(printout t "regra > escolhe-menor-preco-inicio - menor-preco = " ?codigo crlf)
)

(defrule escolhe-menor-preco
	(fornecedor
		(codigo ?codigo)
		(preco ?preco)
	)
	?f <- (menor-preco ?menor-codigo ?menor-preco&:(< ?preco ?menor-preco))
=>
	(retract ?f)
	(assert (menor-preco ?codigo ?preco))
	(printout t "regra > escolhe-menor-preco - menor-preco = " ?codigo crlf)
)

;; Se o fornecedor que tiver o melhor preco e maior confianca
;; tiver a quantidade necessaria, entao ele eh o vencedor

(defrule verifica-quantidade-necessaria-maior-confianca-menor-preco
	(declare (salience -10))
	(maior-confianca ?codigo ?)
	(menor-preco ?codigo ?)
	(fornecedor
		(codigo ?codigo)
		(quantidade ?quantidade)
	)
	(quantidade_necessaria ?quantidade-necessaria&:(<= ?quantidade-necessaria ?quantidade))
=>
	(assert (fornecedor-escolhido ?codigo))
	(printout t "regra > verifica-quantidade-necessaria-maior-confianca-menor-preco - fornecedor-escolhido = " ?codigo crlf)
)

;; Pega apenas o que tem maior confianca, se ele
;; tiver a quantidade necessaria

(defrule quantidade-necessaria-maior-confianca
	(declare (salience -10))
	(maior-confianca ?codigo ?)
	(not (menor-preco ?codigo ?))
	(not (fornecedor-escolhido ?))
	(fornecedor
		(codigo ?codigo)
		(quantidade ?quantidade)
	)
	(quantidade_necessaria ?quantidade-necessaria&:(<= ?quantidade-necessaria ?quantidade))
=>
	(assert (fornecedor-escolhido ?codigo))
	(printout t "regra > quantidade-necessaria-maior-confianca - fornecedor-escolhido = " ?codigo crlf)
)

;; Pega apenas o com menor preco, se ele
;; tiver a quantidade necessaria

(defrule quantidade-necessaria-menor-preco
	(declare (salience -11))
	(menor-preco ?codigo ?)
	(not (maior-confianca ?codigo ?))
	(not (fornecedor-escolhido ?))
	(fornecedor
		(codigo ?codigo)
		(quantidade ?quantidade)
	)
	(quantidade_necessaria ?quantidade-necessaria&:(<= ?quantidade-necessaria ?quantidade))
=>
	(assert (fornecedor-escolhido ?codigo))
	(printout t "regra > quantidade-necessaria-menor-preco - fornecedor-escolhido = " ?codigo crlf)
)

;; Ninguem tem a quantidade necessaria, entao
;; escolhe o de maior confianca

(defrule apenas-quantidade-necessaria
	(declare (salience -15))
	;(not (menor-preco ?codigo ?))
	;(not (maior-confianca ?codigo ?))
	(not (fornecedor-escolhido ?))
	(fornecedor
		(codigo ?codigo)
		(quantidade ?quantidade)
	)
	(quantidade_necessaria ?quantidade-necessaria&:(<= ?quantidade-necessaria ?quantidade))
=>
	(assert (fornecedor-escolhido ?codigo))
	(printout t "regra > apenas-quantidade-necessaria - fornecedor-escolhido = " ?codigo crlf)
)

(defrule ninguem-tem-quantidade-necessaria
	(declare (salience -20))
	(not (fornecedor-escolhido ?codigo))
	(maior-confianca ?codigo ?)
	(fornecedor
		(codigo ?codigo)
		(quantidade ?quantidade)
	)
	(quantidade_necessaria ?quantidade-necessaria&:(> ?quantidade-necessaria ?quantidade))
=>
	(assert (fornecedor-escolhido ?codigo))
	(printout t "regra > ninguem-tem-quantidade-necessaria - fornecedor-escolhido = " ?codigo crlf)
)

;; Retorna o fornecedor escolhido

(defrule retorna-fornecedor-escolhido
	(declare (salience -30))
	(fornecedor-escolhido ?codigo)
=>
	(bind ?*vencedor* ?codigo)
	(printout t "regra > retorna-fornecedor-escolhido = " ?codigo crlf)
	(return ?codigo)
)

;; Usado apenas para testes
;;(reset)
;;(run)
